MODEL FOOD
!
!
!
TABLES
        KONST(10)                ! Se diskdata
!
!
DISKDATA
        KONST  = food.pri       ! Henter salgspris, lagerkostnad, #kategorier
                                ! oljetyper i en kategori og antall perioder
                                ! i nevnte rekkeflge
!
!
LET SALGSP = KONST(1)           ! Salgspris for olje
LET LAGERC = KONST(2)           ! Kostnad ved  ha lager
LET MAXK = KONST(3)             ! Antall kategorier i modellen
LET MAXT = KONST(4)             ! Maks antall typer i en kategori
LET MAXM = KONST(5)             ! Maks antall mnder som det beregnes for
LET MAXX = KONST(6)             ! Maks deltaverdier
LET OVGRH = KONST(7)            ! vre grense
LET NEGRH = KONST(8)            ! Nedre grense
LET LAMAX = KONST(9)            ! Maks lager
LET BRUKMIN = KONST(10)         ! Minimumskrav til bruk under oppg. 12.2
!
!
TABLES
        COST(MAXK*MAXM, MAXT)     ! Kostnad ved aa kjope olje t i
                                  ! periode t
        HARD(MAXK, MAXT)          ! Hardhet til oljetypene
        ISTO(MAXK, MAXT)          ! Initialbeholdning av oljetypene
        USTO(MAXK, MAXT)          ! Krav til utgaaende beholding av
                                  ! oljetypene
        FORBRK(MAXK)              ! Maksforbruk av oljekategori k
                                  ! (lik for alle perioder for hver k)
        MAKST(MAXK)               ! Antall oljetypeer i kategori k
        MAXMND(MAXM)              ! Angir hvilke mnder som velges til
                                  ! oppgave 12.2 (1=valgt mnd., 0 ellers)
        OPGAVE(1)                 ! Angir hvilken oppgave som velges
                                  ! (0= oppg. 12.1 og 1= oppg.12.2
        KS(MAXK, MAXM, MAXT)      ! 3 dim. matrise for kostnader i periode
                                  ! m, for kategori k og type t
        
!
!
DISKDATA
        COST = food.cst         ! Henter priser paa olje i for periode t
        HARD = food.hrd         ! Henter hardhet paa oljevariantene
        ISTO = food.ist         ! henter initialbeholding av raaoljer
        FORBRK = food.for       ! henter maksforbruksverdier for kat. k
        USTO   = food.lgr       ! Henter utgaaende lagerbeholdninger for
                                ! k og t
        MAKST = food.kat        ! Henter antall oljetyper i kategoriene
        MAXMND= food.mnd        ! Henter valgte mnder i oppg. 12.2
        OPGAVE= food.opg        ! Henter valgt oppgavetype
!
!
ASSIGN
                                ! Tilordner 2 dim. kostnads matrise til
                                ! 3 dim. matrise
        KS(K=1:MAXK, M=1:MAXM, T=1:MAKST(K)) = COST((K-1)*MAXM+M, T) 
!
!
VARIABLES
        ko(M=1:MAXM, K=1:MAXK, T=1:MAXT)! olje type i, i kategori k som er
                                        ! kjopt i periode t
        bo(M=1:MAXM, K=1:MAXK, T=1:MAXT)! olje type i, i kategori k som er
                                        ! brukt i periode t
        lo(M=1:MAXM, K=1:MAXK, T=1:MAXT)! olje type i, i kategori k som er 
                                        ! lagret i periode t
        prod(MAXM)                      ! Total olje solgt i periode t
        co(M=1:MAXM, K=1:MAXK,T=1:MAXT) ! kostnader for periode, kategori
                                        ! og type
        x(M=1:MAXM, K=1:MAXK, T=1:MAXT|OPGAVE(1)==1)    ! Deltaverdier for
                                                        ! oppgave 12.2
!
!
CONSTRAINTS
!
!

                        ! Objektfunkjson (maksimering)
PROF:   -SUM(M=1:MAXM,K=1:MAXK,T=1:MAKST(K))            &
        KS(K,M,T)*ko(M,K,T)                             &
        +SUM(M=1:MAXM) SALGSP*prod(M)                   &
        -SUM(M=1:MAXM,K=1:MAXK,T=1:MAKST(K))            &
        LAGERC*lo(M,K,T)                                $
!
!
                        ! Materialbalanse for raaoljer
MB1(M=2:MAXM,K=1:MAXK,T=1:MAKST(K)):                    &
                        lo(M-1,K,T)+ko(M,K,T)-bo(M,K,T) &
                        = lo(M,K,T)
MB2(M=1:1,K=1:MAXK,T=1:MAKST(K)):                       &
                        ISTO(K,T)+ko(M,K,T)-bo(M,K,T)   &
                        = lo(M,K,T)

!
!
!
                        ! Hardhetskrav til oljeblanding
UHRD(M=1:MAXM): SUM(K=1:MAXK,T=1:MAKST(K))              &
                HARD(K,T)*bo(M,K,T)                     &
                - OVGRH*prod(M) < 0
LHRD(M=1:MAXM): SUM(K=1:MAXK,T=1:MAKST(K))              &
                HARD(K,T)*bo(M,K,T)                     &
                - NEGRH*prod(M) >0
!
!
                        ! Produksjonsvolum
VOLUM(M=1:MAXM):                                        &
                SUM(K=1:MAXK,T=1:MAKST(K))              &
                bo(M,K,T) = prod(M)
!
!
                        ! Maksimalforbruk av raaoljer i hver periode
KAT1(M=1:MAXM,K=1:MAXK):                                &
                SUM(T=1:MAKST(K)) bo(M,K,T) < FORBRK(K)
!
!
IF OPGAVE(1)==1         ! Krav til oppgave 12.2
                        ! Maks sum deltaverdier i hver mnd. 
DLTA(M=1:MAXM|MAXMND(M)<>0):                            &
        SUM(K=1:MAXK,T=1:MAKST(K)) x(M,K,T) < 3
!
!
                        ! Hvis olje brukes tilordnes delta verdi
                        ! og olje som brukes m ligge mellom 20 tonn
                        ! og maksimalt forbruk i kategori k 
MND(M=1:MAXM,K=1:MAXK,T=1:MAKST(K) | MAXMND(M)<>0):     &
                bo(M,K,T) - BRUKMIN*x(M,K,T) > 0
MD(M=1:MAXM,K=1:MAXK,T=1:MAKST(K) | MAXMND(M)<>0):      &
                bo(M,K,T) - FORBRK(K)*x(M,K,T) < 0

!
!
                      ! Hvis kategori 1, type 1 eller 2 brukes m kategori 2
                      ! type 3 ogs brukes
BT(M=1:MAXM,K=1:1,T=1:1):                               &
                x(M,K,T) + x(M,K,T+1) - 2*x(M,K+1,T+2) < 0
!                
!
BOUNDS
!
!
x(M=1:MAXM,K=1:MAXK,T=1:MAKST(K)|MAXMND(M)<>0) .BV.
!
!
ENDIF   ! Slutt spesielle krav til oppgave 12.2
!
!
BOUNDS
                        ! Kapasitet paa raavarelageret
lo(M=1:MAXM-1,K=1:MAXK,T=1:MAKST(K)) < LAMAX
!
!
                        ! Ugaaende lagerbeholdning ved beregningsslutt
lo(M=MAXM:MAXM,K=1:MAXK,T=1:MAKST(K)) = USTO(K,T)
!
!
GENERATE
!
!
TABLES
DUALVERD(MAXM,MAXK)
!
!
ASSIGN
       DUALVERD(M=1:MAXM,K=1:MAXK) = dual(KAT1(M,K))        
!
!
PRINT
!
!
! SVAR TIL OPPGAVE 12.1
!
! Maalfunksjonsverdi
PROF
!
!
! Bruk av raastoffer i periode 6
bo(6,1,1)
bo(6,1,2)
bo(6,2,1)
bo(6,2,2)
bo(6,2,3)
!
!
! Lagerbeholdning av raastoffer i periode 2
lo(2,1,1)
lo(2,1,2)
lo(2,2,1)
lo(2,2,2)
lo(2,2,3)

!
!
! Innkjop av de ulike raastoffene i periode 3
ko(3,1,1)
ko(3,1,2)
ko(3,2,1)
ko(3,2,2)
ko(3,2,3)

!
!
! Skyggepriser for raffineringskapasitetene i frste periode
DUALVERD
!
!
! SVAR TIL OPPGAVE 12.2
!
! Mlfunksjonsverdi 12.2
PROF
! Rstoffene som brukes i produksjon i periode 3
bo(3,1,1)
bo(3,1,2)
bo(3,2,1)
bo(3,2,2)
bo(3,2,3)
!
! Lager i periode 2
lo(2,1,1)
lo(2,1,2)
lo(2,2,1)
lo(2,2,2)
lo(2,2,3)

QUIT
